Read_Chunk proc RFile : DWORD, rChunk : DWORD	; Read a Chunk and determine it's ID value
												; return in eax
												
	mov ebx, rChunk
	.if (rChunk == NULL)
		ret
	.endif
	invoke ReadFile,RFile,addr [ebx].Chunk3DS.CID,2,addr NBytesRead,NULL
	mov esi, NBytesRead
	invoke ReadFile,RFile,addr [ebx].Chunk3DS.CLength,4,addr NBytesRead,NULL
	add esi, NBytesRead
	movzx eax, [ebx].Chunk3DS.CID
	mov [ebx].Chunk3DS.CBytesRead, esi
	ret
Read_Chunk endp
Move_ToChunk proc MFile: DWORD, mChunk : DWORD	; Skip a current Chunk as it is not of value
												; or Unsupported
	mov ebx, mChunk
	mov edx, [ebx].Chunk3DS.CLength
	mov eax, [ebx].Chunk3DS.CBytesRead
	sub edx, eax
	invoke SetFilePointer,MFile,edx,NULL,FILE_CURRENT
	ret
Move_ToChunk endp
ReadObjName proc ROChunk : DWORD, ROFile : DWORD, DestString : DWORD,   SizeString : DWORD
; Read the ASCII Name of current Object and keep it for reference [MAX [NB]:=64]
	mov esi, SizeString
	xor ebx, ebx
RO_Name:	
	invoke ReadFile,ROFile,addr DestString[ebx],1,addr NBytesRead,NULL
	.if (byte ptr DestString[ebx]  != NULL)
		.if (ebx < esi)
			add ebx, 1
			jmp RO_Name
		.endif			
	.endif
	add ebx, 1
	mov byte ptr DestString[ebx], NULL
	add [ROChunk],ebx
	PrintString DestString
	ret
ReadObjName endp
ReadVertices proc VFile : DWORD, vChunk : DWORD ; Read all vertices (x,y,z) for this current object
LOCAL TmpMemHandle : DWORD
	mov ebx, MeshNumb			; get index to current Meshstructure= Number of Vertices
	sub ebx, 1
	shl ebx, 6								; Mesh3DS --> 64-byte structure = ( 64 * ?)
	invoke ReadFile,VFile,addr MeshList[ebx].Mesh3DS.mTotV, 2,addr NBytesRead,NULL
	movzx ecx, MeshList[ebx].Mesh3DS.mTotV	; Total numeric number of vertices
	mov edx, vChunk
	mov esi, NBytesRead						; keep update-ing how much of the file read
	mov eax, ecx
	mov edi, ecx
	shl eax, 4								; Vertex3DS --> 16-byte structure = (16 * ?)
	shl ecx, 3								; FileVertex3DS --> 12-byte structure = (8 * ?)
	shl edi, 2								;               -->                   + (4 * ?)
	add MeshList[ebx].Mesh3DS.mMemory, eax	; keep track of amount of memory allocated
	add [edx].Chunk3DS.CBytesRead,esi
	add edi, ecx
	invoke GlobalAlloc,GMEM_FIXED,eax 	; allocate memory for Permanent Vertices
	mov MeshList[ebx].Mesh3DS.mVert, eax
	invoke GlobalAlloc,GMEM_FIXED,edi	; allocate memory for Temp Vertices
	mov TmpMemHandle, eax
	invoke ReadFile,VFile,eax,edi,addr NBytesRead,NULL ; read File Vertices into memory
	mov edx, vChunk
	mov eax, NBytesRead
	mov esi, TmpMemHandle
	mov edi, MeshList[ebx].Mesh3DS.mVert
	movzx ecx , MeshList[ebx].Mesh3DS.mTotV
	add [edx].Chunk3DS.CBytesRead, eax		; keep update-ing how much of the file we read
Copy_Vertices:	
	mov eax, [esi].FileVertex3DS.Vx			; Copy to our internal structure
	mov ebx, [esi].FileVertex3DS.Vy			; We are actually copying REAL4's 
	mov edx, [esi].FileVertex3DS.Vz
	mov [edi].Vertex3DS.Vx, eax
	mov [edi].Vertex3DS.Vy, ebx
	mov [edi].Vertex3DS.Vz, edx
	mov [edi].Vertex3DS.Va, NULL
	add esi, sizeof FileVertex3DS
	add edi, sizeof Vertex3DS
	sub ecx, 1
	jnz Copy_Vertices
	invoke GlobalFree,TmpMemHandle		; Release the Memory of Temp Vertices	
	invoke Move_ToChunk,VFile,vChunk	; skip to the next chunk
	ret
ReadVertices endp
ReadUVCoords proc UVFile : DWORD, uvChunk : DWORD ; Read all uv coords for this current object
	mov ebx, MeshNumb					; get index to current Meshstructure=Number of UV's
	sub ebx, 1
	shl ebx, 6							; Mesh3DS --> 64-byte structure = ( 64 * ?)
	invoke ReadFile,UVFile,addr MeshList[ebx].Mesh3DS.mTotT, 2,addr NBytesRead,NULL
	movzx ecx,  MeshList[ebx].Mesh3DS.mTotT		; Total numeric number of UV coords
	mov esi, NBytesRead					; keep update-ing how much of the file read
	mov edx, uvChunk
	shl ecx, 3							; UVCoord3DS --> 8-byte structure = (8 x ?) 
	add [edx].Chunk3DS.CBytesRead,esi
	add MeshList[ebx].Mesh3DS.mMemory, ecx	; keep track of amount of memory allocated
	mov edi, ecx  
	invoke GlobalAlloc,GMEM_FIXED,ecx	; allocate memory for UV Coords
	mov MeshList[ebx].Mesh3DS.mTexC, eax
	invoke ReadFile,UVFile,eax,edi,addr NBytesRead,NULL ; read UV coords into memory
	mov edx, uvChunk
	mov esi, NBytesRead
	add [edx].Chunk3DS.CBytesRead, esi			; keep update-ing how much of the file we read
	invoke Move_ToChunk,UVFile,uvChunk	; skip to the next chunk
	ret
ReadUVCoords endp
FreeAll3DS proc				; Free all allocated Memory used to load all objects meshes 
	dec MeshNumb            ;**************
	mov ebx, MeshNumb		; which mesh are we viewing
	shl ebx, 6				; 64 byte structures
Free_All:	
	invoke GlobalFree,MeshList[ebx].Mesh3DS.mVert	; free vertices
	invoke GlobalFree,MeshList[ebx].Mesh3DS.mFace	; free face data
	invoke GlobalFree,MeshList[ebx].Mesh3DS.mTexC	; free texture data
	sub ebx, sizeof Mesh3DS							; move to next mesh
	dec MeshNumb
	jns Free_All
	ret
FreeAll3DS endp
ReadDiffuse proc DFile : DWORD, dChunk : DWORD
	mov ebx, MatrNumb					; get index to current Material Number
	sub ebx, 1
	shl ebx, 7							; Mat3DS --> 128-byte structure = (128 * ?)
	invoke ReadFile,DFile,addr MatList[ebx].Mat3DS.matDiff.Header,6,addr NBytesRead,NULL
	mov esi, NBytesRead 
	invoke ReadFile,DFile,addr MatList[ebx].Mat3DS.matDiff.Red,3,addr NBytesRead,NULL
	add esi, NBytesRead
	mov edx, dChunk
	add [edx].Chunk3DS.CBytesRead, esi
	invoke Move_ToChunk,DFile,dChunk	; skip to the next chunk
	ret
ReadDiffuse endp
ReadMeshMaterials proc MIFile : DWORD, miChunk : DWORD
	
	ret
ReadMeshMaterials endp
Read_SubChunk proc RSFile : DWORD, stChunk : DWORD ; Read down into the object hierarcy
LOCAL tmpChunk : Chunk3DS
Read_Recursive:
	mov ebx, stChunk				; Loop until Parent Chunk is fully read
	mov ecx, [ebx].Chunk3DS.CLength
	mov eax, [ebx].Chunk3DS.CBytesRead
	movzx edx , [ebx].Chunk3DS.CID
	.if (edx == NULL)
		ret
	.endif
	.if (eax < ecx)
		jmp RS_Workerloop
	.endif
	ret
RS_Workerloop:
	invoke Read_Chunk,RSFile,addr tmpChunk				; Read Child Chunk and siblings
	PrintHex eax
	.if 	eax == 03D3Dh								; Edit Block Control 
			invoke Read_SubChunk,RSFile,addr tmpChunk
	.elseif eax == 04000h					; Object Name
			mov ebx, MeshNumb
			shl ebx, 6
			mov MeshList[ebx].Mesh3DS.mMemory, NULL
			lea edx, tmpChunk.CBytesRead
			invoke ReadObjName,edx,RSFile, addr MeshList[ebx].Mesh3DS.mName,  sizeof Mesh3DS.mName
			inc MeshNumb
			invoke Read_SubChunk,RSFile,addr tmpChunk
	.elseif eax == 04100h					; Mesh Block Control 
			invoke Read_SubChunk,RSFile,addr tmpChunk
	.elseif eax == 04110h					; Triangle Mesh Vertices
			invoke ReadVertices,RSFile,addr tmpChunk
	.elseif eax == 04120h					; Triangle Mesh Faces
			invoke ReadFaces,RSFile,addr tmpChunk				
	.elseif eax == 04140h					; Triangle Mesh Texture UV
			invoke ReadUVCoords,RSFile,addr tmpChunk	
	;.elseif eax == 04130h					; Triangle Mesh Texture Indexes
	 		;invoke ReadMeshMaterials,RSFile,addr tmpChunk		
	.elseif eax == 0AFFFh					; Material Control Block
			invoke Read_SubChunk,RSFile,addr tmpChunk
	.elseif eax == 0A000h					; Material Name
			mov ebx, MatrNumb
			shl ebx, 7
			lea edx, tmpChunk.CBytesRead
			invoke ReadObjName,edx,RSFile, addr MatList[ebx].Mat3DS.matName, sizeof Mat3DS.matName
			inc MatrNumb
	.elseif eax == 0A020h  					; Material Diffuse Colours
			invoke ReadDiffuse,RSFile, addr tmpChunk	
	.elseif eax == 0A200h   				; Material Texture Map Block Control
			invoke Read_SubChunk,RSFile,addr tmpChunk					
	.elseif eax == 0A300h					; Material Texture Filename
			mov ebx, MatrNumb
			sub ebx, 1
			shl ebx, 7
			lea edx, tmpChunk.CBytesRead
			invoke ReadObjName,edx,RSFile, addr MatList[ebx].Mat3DS.matFile, sizeof Mat3DS.matFile
	.else	
			invoke Move_ToChunk,RSFile,addr tmpChunk	; Skip to next Chunk
	.endif
	mov ebx, stChunk				; Tally Total Bytes Read
	mov ecx, tmpChunk.CLength
	add [ebx].Chunk3DS.CBytesRead, ecx
	jmp Read_Recursive	
Read_SubChunk endp
ReadFaces proc FFile : DWORD, fChunk : DWORD ; Read the face data for the current object
LOCAL TmpMemHandle : DWORD
	mov ebx, MeshNumb			; get index to current Meshstructure= Number of Faces
	sub ebx, 1
	shl ebx, 6								; Mesh3DS --> 64-byte structure = ( 64 * ?)
	invoke ReadFile,FFile,addr MeshList[ebx].Mesh3DS.mTotF, 2,addr NBytesRead,NULL
	movzx eax, MeshList[ebx].Mesh3DS.mTotF	; Total numeric number of Faces
	mov edx, fChunk
	mov edi, eax
	mov esi, NBytesRead						; keep update-ing how much of the file read
	shl eax, 5								; Face3DS --> 32-byte structure = (32 * ?)
	shl edi, 3								; FileFace3DS --> 8-byte structure = (8 * ?)
	add MeshList[ebx].Mesh3DS.mMemory, eax	; keep track of amount of memory allocated
	add [edx].Chunk3DS.CBytesRead,esi
	invoke GlobalAlloc,GMEM_FIXED,eax 	; allocate memory for Permanent Faces
	mov MeshList[ebx].Mesh3DS.mFace, eax
	invoke GlobalAlloc,GMEM_FIXED,edi	; allocate memory for Temp Faces
	mov TmpMemHandle, eax
	invoke ReadFile,FFile,eax,edi,addr NBytesRead,NULL ; read File Faces into memory
	mov edx, fChunk
	mov eax, NBytesRead
	mov esi, TmpMemHandle
	mov edi, MeshList[ebx].Mesh3DS.mFace
	movzx ecx , MeshList[ebx].Mesh3DS.mTotF
	add [edx].Chunk3DS.CBytesRead, eax		; keep update-ing how much of the file we read
Copy_Faces:	
	mov ax, [esi].FileFace3DS.FF_indx0		; Copy into our internal structure
	mov dx, [esi].FileFace3DS.FF_indx1
	mov [edi].Face3DS.F_idx0, ax  
	mov [edi].Face3DS.F_idx1, dx
	mov ax, [esi].FileFace3DS.FF_indx2
	mov dx, [esi].FileFace3DS.FF_indx3
	mov [edi].Face3DS.F_idx2, ax  
	mov [edi].Face3DS.F_idx3, dx
	add esi, sizeof FileFace3DS
	add edi, sizeof Face3DS
	sub ecx, 1
	jnz Copy_Faces
	invoke GlobalFree,TmpMemHandle		; Release the Memory of Temp Faces		
	invoke Read_SubChunk,FFile,fChunk	; Go Look at next chunk
	ret	
ReadFaces endp
CalCNormal proc ; calculate all normals coords for all objects per face
	mov ebx, MeshNumb	
	sub ebx, 1
CNMesh:	
	push ebx				; index to current Mesh Object
	shl ebx, 6
	lea eax, MeshList[ebx]
CNobject:	
	mov   ebx, [eax].Mesh3DS.mFace ; get pointer to start of faces for this object
	mov   edx, [eax].Mesh3DS.mVert ; get pointer to start of vertices for this object
	movzx ecx, [eax].Mesh3DS.mTotF ; number of faces in this object
CNFace:
	movzx esi, [ebx].Face3DS.F_idx0 ; for this face read point index coord 0 } 
	movzx edi, [ebx].Face3DS.F_idx1 ; for this face read point index coord 1 }> of the triangle
	movzx eax, [ebx].Face3DS.F_idx2	; for this face read point index coord 2 }
	shl esi, 4		; scale to index of Vertex = 16 bytes
	shl edi, 4		; "               "
	shl eax, 4		; "               "
	mov [ebx].Face3DS.Fcnormal.Va, NULL	
; -------------------partial-----------------------------------
	movups XMM0, [esi+edx]	; XMM0 = coord 0 a0,z0,y0,x0  -->  z0 - z1/y0 - y1/x0 - x1
	movups XMM1, [edi+edx]  ; XMM1 = coord 1 a1,z1,y1,x1  -->  z1 - z2/y1 - y2/x1 - x2
	movups XMM3, [edi+edx]	; XMM3 = Copy of XMM1
	movups XMM2, [eax+edx]  ; XMM2 = coord 2 a2,z2,y2,x2
; -------------------full--------------------------------------
	subps  XMM0, XMM1	; XMM0 = [V0] --> Va0/Vz0/Vy0/Vx0 -----------------+
	subps  XMM3, XMM2	; XMM3 = [V1] --> Va1/Vz1/Vy1/Vx1 ------+          |
  	movaps XMM4, XMM0	; Copy of V0  --> Va0/Vz0/Vy0/Vx0       |          |
	movaps XMM2, XMM3   ; Copy of V1  --> Va1/Vz1/Vy1/Vx1       |          |
	shufps XMM4, XMM4, 11001001b ;    --> Va0/Vx0/Vz0/Vy0 <-----|----------+
	shufps XMM2, XMM2, 11001001b ;    --> Va1/Vx1/Vz1/Vy1 <-----+
	mulps  XMM4, XMM3   ; Va0 * Va1 / Vx0 * Vz1 / Vz0 * Vy1 / Vy0 * Vx1 
	mulps  XMM2, XMM0   ; Va1 * Va0 / Vx1 * Vz0 / Vz1 * Vy0 / Vy1 * Vx0
	subps  XMM2, XMM4
	; dummy A -->   nrm.a = (v0.a * v1.a) - (v0.a * v1.a)
	; norm  Y -->	nrm.y = (v0.z * v1.x) - (v0.x * v1.z)
	; norm  X -->	nrm.x = (v0.y * v1.z) - (v0.z * v1.y)	
	; norm  Z --> 	nrm.z = (v0.x * v1.y) - (v0.y * v1.x)
	movaps  XMM3, XMM2			  	; XMM3 = XMM2
	mulps   XMM3, XMM3
	movaps  XMM1, XMM2			  	; XMM2 = Na   , Ny   , Nx   , Nz	
	movaps  XMM4, XMM3				; XMM3 = Na*Na, Ny*Ny, Nx*Nx, Nz*Nz
	movhlps XMM0, XMM2            	; XMM0 = n/a  , n/a  , Na   , Ny
	movhlps XMM5, XMM3      		; XMM5 = n/a  , n/a  , Na*Na, Ny*Ny
	shufps  XMM4, XMM4, 11100001b 	; XMM4 = Na*Na, Ny*Ny, Nz*Nz, Nx*Nx 
	shufps  XMM1, XMM1, 11100001b 	; XMM1 = Na   , Ny   , Nz   , Nx
	addss   XMM3, XMM5
	addss   XMM3, XMM4 
	rsqrtss XMM3, XMM3				; 1/sqrt(n.x * n.x + n.y * n.y + n.z * n.z)
	mulss 	XMM2, XMM3
	mulss 	XMM0, XMM3
	mulss 	XMM1, XMM3
	movss  [ebx].Face3DS.Fcnormal.Vz, XMM2			; = Nz * Length
	movss  [ebx].Face3DS.Fcnormal.Vy, XMM0			; = Ny * Length
	movss  [ebx].Face3DS.Fcnormal.Vx, XMM1			; = Nx * Length
	add ebx, sizeof Face3DS
	sub ecx, 1
	jnz CNFace
CNLoop:
	pop ebx
	sub ebx, 1
	jns CNMesh
	ret
CalCNormal endp
Load_3DSModel proc  
	invoke CreateFile,addr FileStr3DS,GENERIC_READ,NULL,NULL,OPEN_EXISTING,
	FILE_ATTRIBUTE_NORMAL,NULL
	test eax, -1
	jz  L_Exit
	mov File3DS, eax
	invoke Read_Chunk, File3DS, addr PRIMChunk	; Check for Valid 3DS File
	.if eax == 04D4Dh							; Primary ID must = 4d4dh for .3ds files
		invoke Read_SubChunk, File3DS, addr PRIMChunk
		call CalCNormal
	.else
		invoke MessageBox,HWND_DESKTOP,addr Error2, addr ErrorA,MB_OK
	.endif
L_Exit:
	invoke CloseHandle,File3DS
	ret
Load_3DSModel endp