.686p
.xmm
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include ogltester.inc

	
.data 
startm db 'Starting OGL loop',0
stuff db 'here goes',0
;**************************************************
;File side structure for 3DS files
;************************************************** 
Chunk3DS Struc 			; 10 bytes file side read header
CID	    	dw ?		; Chunk ID
CLength 	dd ?		; Chunk Length
CBytesRead 	dd ?  		; Bytes Read so far in this chunk
Chunk3DS ends
FileVertex3DS Struc		;File Side Structure vertex x / y / z --> 12 bytes
Vx	REAL4 ?
Vy	REAL4 ?
Vz	REAL4 ?
FileVertex3DS ends
FileFace3DS Struc		;File Side Structure 8 bytes <--
FF_indx0	dw ?				;file coord indx 0 of Triangle
FF_indx1 	dw ?				;file coord indx 1 of Triangle
FF_indx2 	dw ?				;file coord indx 2 of Triangle
FF_indx3 	dw ?				;file Triangle flags
FileFace3DS ends
;**************************************************
;InHouse 3d object structure
;************************************************** 
Vertex3DS Struc			;vertex x / y / z / alpha-filler --> 16 bytes
Vx	REAL4 ?
Vy	REAL4 ?
Vz	REAL4 ?
Va	REAL4 ?
Vertex3DS ends
UVCoord3DS Struc		;uv texture coordinate --> 8 bytes
U_	REAL4 ?
V_	REAL4 ?	
UVCoord3DS ends
Face3DS Struc			;generic face structure per polygon 32 bytes <--
FcmatID		dw ?				;work structure triangle material ID
F_idx0		dw ?				;work structure coord 0 of Triangle
F_idx1 		dw ?				;work structure coord 1 of Triangle
F_idx2 		dw ?				;work structure coord 2 of Triangle
F_idx3 		dw ?				;work structure triangle flags or alpha-filler 
Fcnormal    Vertex3DS <?>		;work structure triangle normals
Fa          db 6 dup (?)		;filler
Face3DS ends
DColor Struc			;generic diffuse colour for material 9 bytes <--
Header  db 6 dup (?)			;diffuse header block
Red		db ?					;red diffuse value
Green	db ?					;green diffuse value
Blue	db ?					;blue diffuse value
DColor ends
Mat3DS Struc			;generic material structure global 128 bytes <--
matMem  dd ?					;amount of memory allocated for this material
matPntr dd ?					;pointer to material
matDiff DColor <>				;diffuse colour of DColor Structure
matName db 47 dup (?)	;material name [NB: max name size]
matFile db 64 dup (?)			;material file name [NB: max name and path]
Mat3DS ends
Mesh3DS Struc			;generic mesh structure per object 64 bytes <--
mMemory			dd ?			;amount of memory allocated for all object components
mFace 			dd ?			;pointer to faces 		
mVert	 		dd ?			;pointer to vertices
mTexC			dd ?			;pointer to texture UV coords
mTotF		 	dw ?			;number of faces
mTotV			dw ?			;number of vertices
mTotT			dw ?			;number of texture UV coords
mName			db 42 dup (?)	;original 3ds object name [NB: max name size]
Mesh3DS ends

MeshList	Mesh3DS 10 dup ({})
MatList		Mat3DS  10 dup ({})
MeshNumb	dd 0
MatrNumb    dd 0
PRIMChunk 	Chunk3DS <0>,<0>,<0>,<0>
File3DS		dd 0
FileStr3DS	db 'tester.3ds',0
NBytesRead  dd 0
Float1 		REAL4 1.0
UnitFloat 	REAL4 0.5,0.5,0.5



F_1000 	REAL8 1000.00
F_010 	REAL8 0.10
F_45 	REAL8 45.0
F_Ratio REAL8 1.33
F_1_00 	REAL8 1.00

F_TransX REAL4 0.00
F_TransY REAL4 0.00
F_TransZ REAL4 -130.0

F_ColorX REAL4 0.00
F_ColorY REAL4 0.20
F_ColorZ REAL4 0.30


Header1 db 'OPENGL',0
Header2 db 'Exploring OpenGL',0

ErrorA  db 'General Failure',0
Error1  db 'No SSE2 support on CPU',0
Error2	db 'Invalid 3DS File',0
Error4  db 'Error creating OpenGL-Class Window',0
Error5  db 'Error creating OpenGL-Instance',0

iccex	INITCOMMONCONTROLSEX 	<?>
.code
;#####################################################################################################		
include TIMERS.asm
include 3dsLoader.asm
OGL_DRAW proc
LOCAL FaceNum : DWORD
LOCAL VertLst : DWORD

 	invoke glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
   	invoke glMatrixMode,GL_MODELVIEW
    invoke glLoadIdentity
    invoke glTranslatef, F_TransX , F_TransY, F_TransZ
    
  	mov ebx, MeshNumb			 
	sub ebx, 1
OGLMesh:	
	push ebx				; index to current Mesh Object
	shl ebx, 6
	lea eax, MeshList[ebx]
OGLObject:	
	mov   ebx, [eax].Mesh3DS.mFace ; get pointer to start of faces for this object
	mov   edx, [eax].Mesh3DS.mVert ; get pointer to start of vertices for this object
	movzx ecx, [eax].Mesh3DS.mTotF ; number of faces in this object
	mov FaceNum, ecx
	mov VertLst, edx
	invoke glBegin,GL_TRIANGLES
	invoke glColor3f, F_ColorX, F_ColorY, F_ColorZ
OGLFace:

	invoke glNormal3f,[ebx].Face3DS.Fcnormal.Vx,[ebx].Face3DS.Fcnormal.Vy,[ebx].Face3DS.Fcnormal.Vz

	movzx edx, [ebx].Face3DS.F_idx0 ; for this face read point index coord 0 } 
	movzx esi, [ebx].Face3DS.F_idx1 ; for this face read point index coord 1 }> of the triangle
	movzx edi, [ebx].Face3DS.F_idx2	; for this face read point index coord 2 }
	shl edx, 4		; scale to index of Vertex = 16 bytes
	shl esi, 4		; "               "
	shl edi, 4		; "   
	add edx, VertLst
	add esi, VertLst
	add edi, VertLst
	invoke glVertex3f,[edx],[edx+4],[edx+8]
	invoke glVertex3f,[esi],[esi+4],[esi+8]
	invoke glVertex3f,[edi],[edi+4],[edi+8]
	add ebx, sizeof Face3DS
	dec FaceNum
	jnz OGLFace
	invoke glEnd
	
    pop ebx
    
  	invoke SwapBuffers,GL_DC
	ret
OGL_DRAW endp
MSG_PUMP proc 
	LOCAL	msg : MSG
MSG_Loop:		; Check for waiting messages
	invoke PeekMessage,ADDR msg,0,0,0,PM_NOREMOVE
	or  eax, eax
	jz	MSG_NO
	invoke	GetMessage,ADDR msg,NULL,0,0
	or  eax, eax
	jz	MSG_Exit
	invoke TranslateMessage,ADDR msg
	invoke DispatchMessage,ADDR msg
	jmp	MSG_Loop
MSG_NO:			; No pending messages: draw the scene
	call OGL_DRAW	
	jmp	MSG_Loop
MSG_Exit:	
	mov	eax, msg.wParam
	ret
MSG_PUMP endp
INIT_OPGL16 proc hWnd:DWORD
LOCAL GLPixelFormat	: PIXELFORMATDESCRIPTOR
;***********************************************************[WINDOW DC]
	invoke GetDC,hWnd		; Get the Window Device Context
	test eax, eax
	jz DP2
	mov GL_DC, eax			; Keep it for all future enquiries
;********************************************************[PIXEL FORMAT]	
	invoke RtlZeroMemory,addr GLPixelFormat,sizeof(PIXELFORMATDESCRIPTOR)
    mov GLPixelFormat.nSize,sizeof(PIXELFORMATDESCRIPTOR)
    mov GLPixelFormat.nVersion	 , 1
    mov GLPixelFormat.dwFlags	 , PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER 
    mov GLPixelFormat.iPixelType , PFD_TYPE_RGBA
    mov GLPixelFormat.cColorBits , 16
    mov GLPixelFormat.cDepthBits , 16
    mov GLPixelFormat.dwLayerMask, PFD_MAIN_PLANE
    invoke ChoosePixelFormat,GL_DC,addr GLPixelFormat
	test eax, eax
	jz DP1
	mov GL_PixelFRMT, eax
	invoke SetPixelFormat,GL_DC,sizeof(PIXELFORMATDESCRIPTOR),addr GLPixelFormat
	test eax, eax
	jz DP1
;***************************************************[OPENGL INITIALIZE]	
	invoke wglCreateContext,GL_DC
	test eax, eax
	jz DP1
	mov GL_Context, eax
	invoke wglMakeCurrent,GL_DC,GL_Context
	test eax, eax
	jz DP0
	invoke ShowWindow,hWnd,SW_SHOW
	invoke SetForegroundWindow,hWnd
	invoke SetFocus,hWnd
	
	invoke glClearColor, 0, 0, 0, Float1
	invoke glEnable,GL_DEPTH_TEST
	invoke glShadeModel,GL_SMOOTH
	invoke glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
	invoke glEnable,GL_CULL_FACE
	
	
   	invoke glViewport,GL_Area.left,GL_Area.top,GL_Area.right,GL_Area.bottom
	invoke glMatrixMode,GL_PROJECTION
	invoke glLoadIdentity
    finit	
    fild GL_Area.right
    fild GL_Area.left
    fsub
    fild GL_Area.bottom
    fild GL_Area.top
    fsub
    fdivp st(1),st(0)
    fstp qword ptr F_Ratio
    invoke gluPerspective, F_45, F_Ratio, F_010, F_1000
    invoke glPolygonMode,GL_FRONT_AND_BACK,GL_LINE
    mov eax, TRUE
    ret
;************************************************[OPENGL ERROR CLEANUP]    
DP0:		
	invoke wglMakeCurrent, NULL, NULL
	invoke wglDeleteContext, GL_Context
DP1:	
	invoke ReleaseDC, hWnd, GL_DC   
DP2:
	invoke UnregisterClass,addr Header1,hInstance
	mov eax, FALSE	 
	ret
INIT_OPGL16 endp
GL_WINDOW proc X_TOP:DWORD,Y_TOP:DWORD,X_BOT:DWORD,Y_BOT:DWORD
LOCAL dwExStyle	: DWORD
LOCAL dwStyle	: DWORD
LOCAL wc		: WNDCLASS
    m2m GL_Area.left	,X_TOP ; Set Drawable OpenGL area 
    m2m GL_Area.top 	,Y_TOP
    m2m GL_Area.right	,X_BOT
    m2m GL_Area.bottom	,Y_BOT
    mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_OWNDC
    mov wc.lpfnWndProc, offset MainLoop ; Set Procedure to handle msg's
    mov wc.cbClsExtra,0
    mov wc.cbWndExtra,0
    m2m wc.hInstance,hInstance
    mov wc.hbrBackground,NULL
    mov wc.lpszMenuName,NULL
    mov wc.lpszClassName, offset Header1 ; Set Class Name
    invoke LoadIcon,NULL,IDI_WINLOGO
    mov wc.hIcon,eax
    invoke LoadCursor,NULL,IDC_ARROW
    mov wc.hCursor,eax
    invoke RegisterClass,addr wc	; Register the Class Name
    test eax, eax
    jz GLW_Exit
    mov dwExStyle,WS_EX_APPWINDOW or WS_EX_WINDOWEDGE
    mov dwStyle, WS_OVERLAPPEDWINDOW ; Set Window to Appropriate Size
    invoke AdjustWindowRectEx,addr GL_Area,dwStyle,FALSE,dwExStyle
    test eax, eax
    jz GLW_Exit   
    mov ebx, dwStyle
    or  ebx, WS_CLIPSIBLINGS or WS_CLIPCHILDREN ; Then Finally Create IT
    invoke CreateWindowEx,dwExStyle,addr Header1,addr Header2,ebx,
    GL_Area.left,GL_Area.top,GL_Area.right,GL_Area.bottom,0,0,hInstance,0
GLW_Exit:    
	ret
GL_WINDOW endp
MainLoop proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
LOCAL WidthSCR,HeightSCR : DWORD
	.if uMsg == WM_COMMAND
		.if wParam == 1000
			invoke	SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL
		.endif
		xor eax, eax
		ret
	.elseif	uMsg == WM_CREATE
		xor eax, eax
		ret
	.elseif	uMsg == WM_SIZE
		mov edx,lParam
		movzx eax,dx
		shr edx,16
		mov WidthSCR, eax
		mov HeightSCR, edx
	    invoke glClear, GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
   	    invoke glViewport,0,0,WidthSCR,HeightSCR
   	    invoke glMatrixMode,GL_PROJECTION
   		invoke glLoadIdentity 
   		finit	
    	fild GL_Area.right
    	fild GL_Area.left
    	fsub
    	fild GL_Area.bottom
    	fild GL_Area.top
    	fsub
    	fdivp st(1),st(0)
    	fstp qword ptr F_Ratio
    	invoke gluPerspective, F_45, F_Ratio, F_010, F_1000
		xor eax, eax
		ret
	.elseif	uMsg == WM_CLOSE
		invoke wglMakeCurrent, NULL, NULL
		invoke wglDeleteContext, GL_Context
		invoke ReleaseDC, hWin, GL_DC 
		invoke UnregisterClass,addr Header1,hInstance
		invoke DestroyWindow,hWin
		ret
	.elseif uMsg == WM_DESTROY
		invoke	PostQuitMessage,NULL
		xor eax, eax
		ret 
	.endif
	invoke	DefWindowProc,hWin,uMsg,wParam,lParam
	ret
MainLoop endp
CheckCPU_SSE2 proc		
    pushfd              ; Check for CPUID function support -> EFLAGS 
    pop  eax            ; - get a copy in eax 
	mov  ebx, eax		; - store a copy in ebx aswell [copy1]
    xor  eax, 200000h   ; set bit 21 to NULL
    push eax            ; push to STACK
    popfd               ; get modified flags into EFLAGS
    pushfd
    pop  eax			; - get EFLAGS [copy2] 
    xor  eax, ebx       ; compare [copy1] to [copy2]
    jz   C_Exit			; was bit 21 changed to 1 
    					; No  = it's VERY OLD! and does not support CPUID
    					; Yes = OK let's look at it further re : CPUID 
	mov eax, 1			; Check for SSE2 Support on CPU
	CPUID				; CPU Version & Feature Get Function : 1
	or edx, 2000000h    ; look at bit 26 for [SSE2 Support]
	jz C_Exit			; - No  = Nope it ain't got what it takes !
						; - Yes = We'll use it then !
	mov eax, TRUE
C_Exit:
	ret	
CheckCPU_SSE2 endp
MainINIT proc 
	
	call CheckCPU_SSE2				; First check for CPU with SSE2
	test eax, eax
	jz Main_Exit4
	invoke GL_WINDOW,30,30,500,400  ; Create our Basic Window  
	test eax, eax
	jz Main_Exit2
	mov OPGLWin, eax
	invoke INIT_OPGL16,eax			; Start OpenGL instance with our Basic Window 
	test eax, eax
	jz Main_Exit1
	call Load_3DSModel
	call MSG_PUMP					; Enter Message Pump loop until Exit
	jmp Main_Exit
Main_Exit4:							; *** Doom's Day Message to user on Error ***
	invoke MessageBox,HWND_DESKTOP,addr Error1,addr ErrorA,MB_OK or MB_ICONEXCLAMATION
	jmp Main_Exit
Main_Exit2:		
	invoke MessageBox,HWND_DESKTOP,addr Error4,addr ErrorA,MB_OK or MB_ICONEXCLAMATION
	jmp Main_Exit
Main_Exit1:	
	invoke MessageBox,HWND_DESKTOP,addr Error5,addr ErrorA,MB_OK or MB_ICONEXCLAMATION
Main_Exit:
;*********
	
	ret
MainINIT endp

start:
	invoke GetModuleHandle,NULL
	mov hInstance, eax
	invoke LoadIcon,NULL,IDI_APPLICATION	
	invoke InitCommonControls
	mov	iccex.dwSize,sizeof INITCOMMONCONTROLSEX    
  	mov	iccex.dwICC,ICC_DATE_CLASSES		
	invoke InitCommonControlsEx,offset iccex
	call MainINIT
	call FreeAll3DS	

	invoke ExitProcess,0
end start